Option Explicit ' ϐ̐錾v.
' iTunes őI𒆂̃gbÑtKitB[h𖄂߂XNvg.

' 萔`.
const DF_FILE_NAME_KANJI      = "tmp\\kanji.txt"
const DF_FILE_NAME_HIRA       = "tmp\\hira.txt"
const DF_FILE_NAME_RESULT     = "result.txt" ' rU肪ɏIꍇɍ쐬t@C.
const DF_K2H_CONVERTER_FILE_NAME = "k2h_convert.bat"
const DF_H2R_DICT_FILE_NAME      = "dict_h2r.txt"
const DF_WORD2H_DICT_FILE_NAME   = "dict_word2h.txt"

const DF_CONV_MODE_NULL = 0 '
const DF_CONV_MODE_H    = 1 'Ђ炪
const DF_CONV_MODE_R    = 2 '[}
const DF_CONV_MODE_C    = 3 'NA

Dim g_trackFieldNameList
g_trackFieldNameList = Array("Name", "Artist", "AlbumArtist", "Album")
Dim g_convMode
g_convMode = DF_CONV_MODE_NULL
Dim g_isForceChange
g_isForceChange = False	' tKitB[hłɖ܂ĂƂɋ邩.

' eIuWFNg쐬.
Dim g_dictHira2Roma
Set g_dictHira2Roma       = CreateObject("Scripting.Dictionary") ' Ђ炪ȁ[}
Dim g_dictWord2Hira
Set g_dictWord2Hira    = CreateObject("Scripting.Dictionary") ' PꁨЂ炪Ȏ

Dim g_fileSystem
Set g_fileSystem = CreateObject("Scripting.FileSystemObject")
Dim g_iTunesApp
Set g_iTunesApp = CreateObject("iTunes.Application")

execMain 'Cs

Set g_dictHira2Roma = Nothing
Set g_dictWord2Hira = Nothing
Set g_fileSystem = Nothing
Set g_iTunesApp = Nothing

Sub execMain()
	'ǂݍ.
	readDict g_dictHira2Roma      , DF_H2R_DICT_FILE_NAME
	readDict g_dictWord2Hira   , DF_WORD2H_DICT_FILE_NAME
	
	Dim args
	Set args = WScript.Arguments
	If 0 < args.Count Then
		Select Case args.item(0)
		Case "-h"
			g_convMode = DF_CONV_MODE_H
		Case "-r"
			g_convMode = DF_CONV_MODE_R
		Case "-c"
			g_convMode = DF_CONV_MODE_C
			g_isForceChange = True
		End Select
	End If
	If g_convMode = DF_CONV_MODE_NULL Then
		makeError "sł"
	End If
	
	Dim selectedTracks
	Set selectedTracks = g_iTunesApp.SelectedTracks
	Dim trackCnt
	trackCnt = 0
	If Not( selectedTracks is Nothing ) Then
		trackCnt = selectedTracks.Count
	End If

	If trackCnt = 0 Then
		makeError "gbNIĂ"
	Else
		writeTrackFields DF_FILE_NAME_KANJI, selectedTracks, trackCnt
		runK2H DF_FILE_NAME_KANJI, DF_FILE_NAME_HIRA
		setRuby DF_FILE_NAME_HIRA, DF_FILE_NAME_RESULT, selectedTracks, trackCnt
	End If
End Sub

' eLXgo.
Sub writeText(filename, text)
	Dim file
	Set file = g_fileSystem.OpenTextFile(filename, 2, True)
	file.WriteLine(text)
	file.Close
	Set file = Nothing
End Sub

'	PꎫɊ܂܂tB[h̕ϊ.
'	tB[ht@Cɏo.
Sub writeTrackFields(filename, selectedTracks, trackCnt)
	On Error Resume Next
	Dim file
	Set file = g_fileSystem.OpenTextFile(filename, 2, True)
	checkError ""
	On Error Goto 0
	Dim i
	For i = 1 to trackCnt
		Dim track
		Set track = selectedTracks.Item( i )
		
		Dim f_i
		For f_i = 0 To UBound(g_trackFieldNameList)
			Dim fieldName
			fieldName = g_trackFieldNameList(f_i)
			Dim baseText
			baseText = ""
			Execute "baseText = track." & fieldName
			Dim destText
			destText = baseText
			If g_dictWord2Hira.Exists(baseText) Then
				' Pꎫ烋r擾.
				destText = g_dictWord2Hira.Item(baseText)
			End If
			WScript.StdOut.WriteLine destText
			file.WriteLine(destText)
		Next
	Next
	
	file.Close
	Set file = Nothing
End Sub

' o͂ꂽrt@Cǂݍ + gbÑrU
Sub setRuby(filenameHira, filenameResult, selectedTracks, trackCnt)
	Dim outLine
	Dim file
	On Error Resume Next
	Set file = g_fileSystem.OpenTextFile(filenameHira)
	checkError ""
	On Error Goto 0
	
	Dim resultText
	resultText = ""
	
	Dim i
	For i = 1 to trackCnt
		Dim track
		Set track = selectedTracks.Item( i )
		
		Dim f_i
		For f_i = 0 To UBound(g_trackFieldNameList)
			Dim fieldName
			fieldName = g_trackFieldNameList(f_i)
			Dim sortFieldName
			sortFieldName = "sort" & fieldName
			Dim baseText
			Dim sortText
			Execute "baseText = track." & fieldName
			Execute "sortText = track." & sortFieldName
			
			Dim afterText
			afterText = getSortText( file.ReadLine(), g_convMode )
			If baseText <> "" and (sortText = "" or g_isForceChange) Then
				Execute "track." & sortFieldName & " = afterText"
				outLine = fieldName & ": " &  baseText & " -> " & afterText & vbCrLf
				resultText = resultText & outLine
				WScript.StdOut.Write outLine
			Else
				outLine = fieldName & ": " &  baseText & " (pass)" & vbCrLf
				resultText = resultText & outLine
				WScript.StdOut.Write outLine
			End If
		Next
		
		WScript.StdOut.WriteLine "i:" & makeProgressBarText(i, trackCnt, 40) & " (" & i & "/" & trackCnt & ")"
	Next
	
	' (r)t@Cɏo.
	writeText fileNameResult, resultText
End Sub
		
' vOXo[ۂeLXg쐬.
'
' [/////____]
'
Function makeProgressBarText(value, valueMax, width)
	Dim text
	text = "["
	Dim progressBarNum
	progressBarNum = (int)(value * width / valueMax)
	Dim i
	For i = 1 To width
		If i <= progressBarNum Then
			text = text & "/"
		Else
			text = text & " "
		End If
	Next
	text = text & "]"
	makeProgressBarText = text
End Function


'Ђ炪ȕϊ
Sub runK2H(srcFilename, destFilename)
	Dim shell
	Set shell = CreateObject("WScript.Shell")
	Dim retVal
	retVal = shell.Run(DF_K2H_CONVERTER_FILE_NAME & " " & srcFilename & " " & destFilename, 1, True)
	Set shell = Nothing
	
End Sub

'\[g(ӂ肪)̎擾
Function getSortText( str, convMode )
	Dim dest
	dest = ""

	If str <> "" Then
		'Pڂ擾
		Dim tmpChar
		tmpChar = Left(str, 1)

		'PڂSpɊ܂܂Ăϊ.
		If (Asc(tmpChar) And &HFF00) <> 0 Then
			Select Case convMode
			Case DF_CONV_MODE_R
				' Ђ炪Ȃ[}.
				Dim strLen
				strLen = Len(str)
				Dim i
				For i = 1 To strLen
					tmpChar = Mid(str, i, 1)
					Dim outChar
					If g_dictHira2Roma.Exists(tmpChar) Then
						outChar = g_dictHira2Roma.Item(tmpChar)
					Else
						outChar = tmpChar
					End If
					dest = dest + outChar
				Next
			Case DF_CONV_MODE_H
				dest = str
			Case DF_CONV_MODE_C
				dest = ""
			End Select
		End If
	End If

	getSortText = dest

End Function

' ̓ǂݍ.
Sub readDict(dict, filename)
	Dim file
	Set file = g_fileSystem.OpenTextFile(filename)
	Dim rowCnt
	rowCnt = 1
	Do While file.AtEndOfStream <> True
		Dim row
		row = file.ReadLine()
		Dim tmpChar
		If 0 < Len(row) And Left(row, 1) <> "#" Then
			' 󔒍sƍs#s͖.
			Dim cols
			cols = Split(row, vbTab, -1, vbTextCompare)
			if UBound(cols) <> 1 Then
				makeError filename & "ɕsȍs܂܂Ă܂B s:" & rowCnt & ":" & row
			End if
			Dim key
			key   = cols(0)
			Dim value
			value = cols(1)
			dict.Add key, value
		End If
		rowCnt = rowCnt + 1
	Loop
	file.Close
End Sub

'bZ[WfāAG[I.
Sub makeError(str)
	WScript.Echo _
		vbCrLf & _
		str & vbCrLf & _
		""
	WScript.Quit 2
End Sub
